<template>
    <v-row id="chart" class="d-flex">
        <v-col class="px-0" cols="12" lg="8" no-gutters>
            <apexchart type="line" ref="graph" height="350px" :options="chartOptions" :series="series"></apexchart>
        </v-col>
        <v-col class="px-0" cols="12" lg="4" no-gutters>
            <v-card flat tile class="d-flex total-views" height="290px" color="#feca38">
                <div>
                    <span class="title-kpi"
                        >Visitas Totales
                        <p style="font-size: 70px;">{{ totalViews }}</p></span
                    >
                </div>
            </v-card>
        </v-col>
    </v-row>
</template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from 'vue-property-decorator';
import { RecordMenuViews } from '@/model/kpi/View';

interface Graph {
    updateOptions: Function;
    updateSeries: Function;
}

@Component
export default class GraphCounterLine extends Vue {
    @Prop({ default: () => [] })
    data!: RecordMenuViews[];
    totalViews = 0;
    series = [
        {
            name: 'Views',
            data: []
        }
    ];

    chartOptions = {
        chart: {
            id: 'line-datetime',
            type: 'area',
            offsetY: -29.5,
            animations: {
                enabled: true,
                easing: 'easeinout',
                speed: 800,
                animateGradually: {
                    enabled: true,
                    delay: 150
                },
                dynamicAnimation: {
                    enabled: true,
                    speed: 35
                }
            },
            dataLabels: {
                enabled: true
            },
            selection: {
                enabled: false
            },
            zoom: {
                enabled: false
            },
            toolbar: {
                show: false
            }
        },
        grid: {
            show: true,
            position: 'back',
            borderColor: '#000',
            row: {
                colors: '#000',
                opacity: 1
            }
        },
        tooltip: {
            followCursor: false,

            x: {
                format: 'dd MMM yyyy'
            }
        },
        yaxis: {
            labels: {
                show: false
            },
            title: {
                text: 'VISITAS',
                rotate: 90,
                offsetX: 0,
                offsetY: 90
            },
            axisTicks: {
                show: true,
                borderType: 'solid',
                color: '#feca38',
                width: 20,
                offsetX: 2
            }
        },
        markers: {
            size: 3
        },
        xaxis: {
            tooltip: {
                enabled: false
            },
            labels: {
                show: false
            },
            title: {
                offsetX: -400,
                offsetY: 10,
                text: 'HORA'
            },
            axisTicks: {
                show: true,
                borderType: 'solid',
                color: '#feca38',
                height: 20,
                offsetY: -15
            },
            axisBorder: {
                show: false
            },
            type: 'datetime'
        },
        colors: ['#feca38']
    };

    selection = 'all';
    @Watch('data')
    onChangeData(newData: RecordMenuViews[]) {
        const dates = newData.map(data => data.date.toString());
        const views = newData.map(data => data.view);
        ((this.$refs.graph as unknown) as Graph).updateOptions({ labels: dates });
        ((this.$refs.graph as unknown) as Graph).updateSeries([{ name: 'Views', data: views }]);
        this.totalViews = views.reduce((a, b) => a + b);
    }
}
</script>

<style lang="scss">
.total-views {
    right: 10px;
    justify-content: center;
    align-items: center;

    @media (max-width: 600px) {
        right: 0;
    }
}
</style>
